/**
 * Workflow step select javascript.
 *
 * @module     tool_trigger/workflow
 * @class      Workflow
 * @copyright  2018 Matt Porritt <mattp@catalyst-au.net>
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 * @since      3.4
 */
define("tool_trigger/step_select",["jquery","core/str","core/modal_factory","core/modal_events","core/templates","core/ajax","core/fragment","core/notification"],(function($,Str,ModalFactory,ModalEvents,Templates,ajax,Fragment,Notification){var contextid,modalObj,StepSelect={},spinner='<p class="text-center"><i class="fa fa-spinner fa-pulse fa-2x fa-fw"></i><span class="sr-only">Loading...</span></p>';function getParentFormSteps(){var stepsjson=$("[name=stepjson]").val(),steps=[];return""!==stepsjson&&(steps=JSON.parse(stepsjson)),steps}function setCurrentFormSteps(steps){$("[name=stepjson]").val(JSON.stringify(steps)),$("[name=isstepschanged]").val(1)}function updateModalBody(){var params={jsonformdata:JSON.stringify({})};modalObj.setBody(spinner),modalObj.setBody(Fragment.loadFragment("tool_trigger","new_base_form",contextid,params))}function updateTable(stepData){var tableData={rows:stepData.map((function(step,stepidx){return{name:step.name,typedesc:step.typedesc,stepdesc:step.stepdesc,steporder:stepidx}}))};Templates.render("tool_trigger/workflow_steps",tableData).then((function(html){$("#steps-table").html(html),setupTableHandlers()})).fail((function(){Notification.exception({message:"Error updating steps table"})}))}function processModalForm(e){e.preventDefault();var $stepform=modalObj.getRoot().find("form"),curstep=$stepform.serializeArray().reduce((function(finalobj,field){if(field.name.endsWith("[]")){var fieldname=field.name.substring(0,field.name.length-2);void 0===finalobj[fieldname]?finalobj[fieldname]=[field.value]:finalobj[fieldname].push(field.value)}else"sesskey"===field.name||field.name.startsWith("_qf__")||field.value.startsWith("_qf__")||(finalobj[field.name]=field.value);return finalobj}),{});curstep.stepdesc=$("[name=stepclass] option:selected").text(),curstep.typedesc=$("[name=type] option:selected").text(),ajax.call([{methodname:"tool_trigger_validate_form",args:{stepclass:curstep.stepclass,jsonformdata:JSON.stringify($stepform.serialize())}}])[0].done((function(){var steps=getParentFormSteps();curstep.steporder>=0?steps[curstep.steporder]=curstep:(steps.push(curstep),curstep.steporder=steps.length-1),setCurrentFormSteps(steps),updateTable(steps),modalObj.hide()})).fail((function(){renderStepForm(curstep.type,curstep.stepclass,"",$stepform.serialize())}))}function getStepsOfType(valfilter){ajax.call([{methodname:"tool_trigger_step_by_type",args:{steptype:valfilter}}])[0].done((function(response){var events;events=response,$("[name=stepclass]").empty().append($("<option>",{value:"",text:"Choose..."})),$.each(events,(function(i,event){$("[name=stepclass]").append($("<option>",{value:event.class,text:event.name}))}))}))}function renderStepForm(steptype,stepclass,formdefaults,formsubmission,steporder){void 0===formdefaults&&(formdefaults=""),void 0===formsubmission&&(formsubmission=""),void 0===steporder&&(steporder=0),modalObj.setBody(spinner),modalObj.setBody(Fragment.loadFragment("tool_trigger","new_step_form",contextid,{steptype:steptype,stepclass:stepclass,defaults:JSON.stringify(formdefaults),ajaxformdata:formsubmission,event:$("[name=eventtomonitor]").val(),existingsteps:JSON.stringify(getParentFormSteps()),steporder:steporder}))}function swapSteps(steps,pos1,pos2){var step1=steps[pos1],step2=steps[pos2];step1.steporder=pos2,step2.steporder=pos2,steps[pos1]=step2,steps[pos2]=step1;var $rows=$("tr.tool-trigger-step-table-row"),$row1=$rows.eq(pos1),$row2=$rows.eq(pos2),row1height=$row1.height(),row2height=$row2.height(),row1color=$row1.find("th").css("background-color"),row2color=$row2.find("th").css("background-color");$([$row1,$row2]).each((function(idx,row){row[0].style.position="relative",row[0].style.top="0",row[0].style.transition="top 400ms",row.find("th,td").each((function(idx,cell){cell.style.transition="background-color 400ms"}))})),window.setTimeout((function(){$row1[0].style.top=row2height+"px",$row1.find("td,th").each((function(idx,cell){cell.style.backgroundColor=row2color})),$row2[0].style.top=-1*row1height+"px",$row2.find("td,th").each((function(idx,cell){cell.style.backgroundColor=row1color}))})),$row1.find(".tool-trigger-step-movedown").fadeTo(400,.1),$row2.find(".tool-trigger-step-moveup").fadeTo(400,.1).promise().always((function(){setCurrentFormSteps(steps),updateTable(steps)}))}function setupTableHandlers(){$(".tool-trigger-step-moveup").slice(1).removeClass("tool-trigger-initial-hidden").on("click",(function(){var steps=getParentFormSteps(),steporder=$(this).data("steporder");return 0===steporder||swapSteps(steps,steporder-1,steporder),!0})),$(".tool-trigger-step-movedown").slice(0,-1).removeClass("tool-trigger-initial-hidden").on("click",(function(){var steps=getParentFormSteps(),steporder=$(this).data("steporder");return steporder>=steps.length-1||swapSteps(steps,steporder,steporder+1),!0})),$(".tool-trigger-step-edit").removeClass("tool-trigger-initial-hidden").on("click",(function(){modalObj.setBody(spinner),modalObj.show();var steps=getParentFormSteps(),steporder=$(this).data("steporder"),step=steps[steporder];renderStepForm(step.type,step.stepclass,step,void 0,steporder)})),$(".tool-trigger-step-delete").removeClass("tool-trigger-initial-hidden").on("click",(function(){var steps=getParentFormSteps(),steporder=$(this).data("steporder");return steps.splice(steporder,1),steporder<=steps.length&&steps.slice(steporder).forEach((function(step){step.steporder=step.steporder-1})),setCurrentFormSteps(steps),$(this).closest("tr").fadeOut((function(){updateTable(steps)})),!0}))}return StepSelect.init=function(context){contextid=context,Str.get_string("modaltitle","tool_trigger").then((function(title){ModalFactory.create({type:ModalFactory.types.SAVE_CANCEL,title:title,body:spinner,large:!0},$("#id_stepmodalbutton")).done((function(modal){(modalObj=modal).getRoot().on(ModalEvents.save,processModalForm),modalObj.getRoot().on(ModalEvents.hidden,updateModalBody),$("body").on("change","[name=type]",(function(){getStepsOfType(this.value)})),$("body").on("change","[name=stepclass]",(function(){renderStepForm($("[name=type]").val(),this.value,"","",-1)})),updateModalBody()}))})),setupTableHandlers()},StepSelect}));

//# sourceMappingURL=step_select.min.js.map